
#include "stm32f10x_tim.h"
#include "stm32f10x_rcc.h"

void delay_config(void)                 
{
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE); //delay clock
  TIM4->PSC=72-1;
}

void delay_us(unsigned int usec)                 // Delay in us
{
  TIM4->ARR=usec;
  TIM4->DIER = TIM_DIER_UIE;
  TIM4->SR &= ~TIM_SR_UIF;
  TIM4->CR1 &= ~TIM_CR1_ARPE;
  TIM4->SR = 0x00;
  TIM4->CR1 |= TIM_CR1_CEN;

  while (TIM4->SR == 0)
  {}
}

void delay_ms(unsigned int msec)            // Delay in ms
{
 uint16_t volatile i;
 for(i=0; i<msec; i++) delay_us(1000);
}


